﻿using parkMonitor.entity;
using parkMonitor.model;
using parkMonitor.server;
using parkMonitor.server.CoreThread;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MySql.Data.MySqlClient;
using parkMonitor.DataBase;
using System.Threading;
using parkMonitor.LOG;

namespace parkMonitor.bll
{
    /// <summary>主业务逻辑</summary>
    public class MainBll
    {
        public void init()
        {
            //中控状态监控服务
            PcStatusServer.ins.start();
            //监控线程
            //PLCMonitorServer.ins.Start();
            var monitorThread = EquipmentSimpleFactory.ins.CreateEquipment(EquipmentName.Monitor);
            if (monitorThread != null)
            {
                monitorThread.Start();
            }
            //核心线程
            var coreThread = EquipmentSimpleFactory.ins.CreateEquipment(EquipmentName.Core);
            if (coreThread != null)
            {
                Task.Factory.StartNew(() =>
                {
                    coreThread.Start();
                    (coreThread as ICoreThreadDoWorking).BeginWorking();
                });
            }

            ////日志文件执行数据库操作
            //Task.Factory.StartNew(() =>
            //{
            //    while (!EntityForCore.ins.globalStatus)
            //    {
            //        Thread.Sleep(1000);
            //    }
            //    lock (Parking_Space.spaceLock)
            //    {
            //        string sqlStatus;
            //        string sqlMsg;
            //        int count;
            //        Log.ReadLog(out sqlStatus, out sqlMsg, out count);
            //        if (count-- > 0)
            //        {
            //            if (sqlStatus == "1")
            //            {
            //                int parkingRecordsID = 0;
            //                try
            //                {
            //                    using (MySqlConnection conn = new MySqlConnection(DBConnection.remoteConf))
            //                    {
            //                        Operation.TryOpen(conn);
            //                        Operation.MyTransaction(conn, sqlMsg, out parkingRecordsID);
            //                    }
            //                }
            //                catch
            //                {
            //                    throw;
            //                }
            //            }
            //            if (sqlStatus == "0")
            //            {
            //                int temp;
            //                try
            //                {
            //                    using (MySqlConnection conn = new MySqlConnection(DBConnection.remoteConf))
            //                    {
            //                        Operation.TryOpen(conn);
            //                        Operation.MyTransaction(conn, sqlMsg, out temp);
            //                    }
            //                }
            //                catch
            //                {
            //                    throw;
            //                }
            //            }
            //        }
            //    }
            //});
            //主窗口关闭事件
            CmdServer.ins.listen(CmdType.MainWinClosed, () =>
            {
                coreThread.Stop();
                monitorThread.Stop();
            });
        }      
    }
}
