﻿using MySql.Data.MySqlClient;
using parkMonitor.DataBase;
using parkMonitor.entity;
using parkMonitor.server.CoreThread;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace parkMonitor.controlPanel
{
    public partial class ControlPanel : Form
    {
        public static ControlPanel ins = null;

        Dictionary<int, CheckBox> IndexCbMap = null;

        public ControlPanel()
        {
            InitializeComponent();
            IndexCbMap = new Dictionary<int, CheckBox>();
            //BufferList.Controls.Add(flp_buffer);
            DisplayBufferStatus();
            UpdateConfirmState();
        }

        public void UpdateConfirmState()
        {
            if (ParkingBufferManager.ins != null)
            {
                if (ParkingBufferManager.ins.checkedManually)
                {
                    lb_confirmed.Text = "缓冲位已确认";
                }
                else
                {
                    lb_confirmed.Text = "缓冲位未确认";
                }
            }
        }

        public void DisplayBufferStatus()
        {
            if (IndexCbMap == null) { IndexCbMap = new Dictionary<int, CheckBox>(); }
            if (ParkingBufferManager.ins != null)
            {
                if (IndexCbMap.Count != ParkingBufferManager.ins.bufferCount)
                {
                    flp_buffer.Controls.Clear();
                    for (int i = 0; i < ParkingBufferManager.ins.bufferCount; i++)
                    {
                        ParkingBuffer temp = ParkingBufferManager.ins.bufferList[i];
                        CheckBox cb = new CheckBox();
                        cb.Text = "第 " + temp.bufferID + " 号缓冲位";
                        cb.Checked = temp.occupied;
                        IndexCbMap.Add(i, cb);
                        flp_buffer.Controls.Add(cb);
                    }
                }
                else
                {
                    for (int i = 0; i < ParkingBufferManager.ins.bufferCount; i++)
                    {
                        IndexCbMap[i].Checked = ParkingBufferManager.ins.bufferList[i].occupied;
                    }
                }
            }
        }

        private void btn_refresh_Click(object sender, EventArgs e)
        {
            DisplayBufferStatus();
            UpdateConfirmState();
        }

        private void btn_buffer_confirm_Click(object sender, EventArgs e)
        {
            if (IndexCbMap == null) { IndexCbMap = new Dictionary<int, CheckBox>(); }
            if (ParkingBufferManager.ins != null && IndexCbMap.Count == ParkingBufferManager.ins.bufferCount)
            {
                for (int i = 0; i < ParkingBufferManager.ins.bufferCount; i++)
                {
                    ParkingBufferManager.ins.bufferList[i].occupied = IndexCbMap[i].Checked;
                }
            }
            UpdateConfirmState();
            if (!ParkingBufferManager.ins.checkedManually)
            {
                lb_confirmed.Text = "缓冲位已确认";
            }
            else
            {
                lb_confirmed.Text = "缓冲位已修改";
            }
            ParkingBufferManager.ins.checkedManually = true;
        }

        private void btn_remoteDB_Click(object sender, EventArgs e)
        {
            bool initState = false;
            if (Operation.malfunctionRemote)
            {
                using (MySqlConnection conn = DBConnectionPool.getPool(DBConnection.remoteConf).getConnection())
                //using (MySqlConnection conn = new MySqlConnection(DBConnection.remoteConf))
                {
                    Operation.TryOpen(conn);
                    initState = conn.Ping();
                    Operation.DBClose(conn,null,null);
                }
                if (initState)
                {
                    Operation.malfunctionRemote = false;
                    MessageBox.Show("远端数据库已成功复位");
                }
            }
        }

        private void btn_localDB_Click(object sender, EventArgs e)
        {
            bool initState = false;
            if (Operation.malfunctionLocal)
            {
                using (MySqlConnection conn = DBConnectionPool.getPool(DBConnection.remoteConf).getConnection())
                //using (MySqlConnection conn = new MySqlConnection(DBConnection.remoteConf))
                {
                    Operation.TryOpen(conn);
                    initState = conn.Ping();
                    Operation.DBClose(conn, null, null);
                }
                if (initState)
                {
                    Operation.malfunctionLocal = false;
                    MessageBox.Show("本地数据库已成功复位");
                }
            }
        }

        private void btn_reInit_Click(object sender, EventArgs e)
        {
            InitWin iw = new InitWin();
            iw.ShowDialog();
        }
    }
}
